5 ## This script is the front-end to the build system. It provides a similar
6 ## interface to standard configure scripts with some extra bits for dealing
7 ## with toolchains that differ from the standard POSIX interface and
8 ## for extracting subsets of the source tree. In theory, reusable parts
9 ## of this script were intended to live in build/make/configure.sh,
10 ## but in practice, the line is pretty blurry.
12 ## This build system is based in part on the FFmpeg configure script.
15 #source_path="`dirname \"$0\"`"
17 . "${source_path}/build/make/configure.sh"
23 ${toggle_libs} don't build libraries
24 ${toggle_examples} don't build examples
25 --libc=PATH path to alternate libc
26 --as={yasm|nasm|auto} use specified assembler [auto, yasm preferred]
27 ${toggle_fast_unaligned} don't use unaligned accesses, even when
28 supported by hardware [auto]
29 ${toggle_codec_srcs} in/exclude codec library source code
30 ${toggle_debug_libs} in/exclude debug version of libraries
31 ${toggle_md5} support for output of checksum data
32 ${toggle_static_msvcrt} use static MSVCRT (VS builds only)
33 ${toggle_vp8} VP8 codec support
34 ${toggle_psnr} output of PSNR data, if supported (encoders)
35 ${toggle_mem_tracker} track memory usage
36 ${toggle_postproc} postprocessing
37 ${toggle_multithread} multithreaded encoding and decoding.
38 ${toggle_spatial_resampling} spatial sampling (scaling) support
39 ${toggle_realtime_only} enable this option while building for real-time encoding
40 ${toggle_runtime_cpu_detect} runtime cpu detection
41 ${toggle_shared} shared library support
42 ${toggle_small} favor smaller size over speed
43 ${toggle_postproc_visualizer} macro block / block level visualizers
46 Codecs can be selectively enabled or disabled individually, or by family:
49 --disable-<codec>-encoder
50 --disable-<codec>-decoder
52 Codecs available in this distribution:
54 #restore editor state '
60 for c in ${CODECS}; do
62 if [ "${family}" != "${last_family}" ]; then
63 [ -z "${str}" ] || echo "${str}"
64 str="$(printf ' %10s:' ${family})"
66 str="${str} $(printf '%10s' ${c#*_})"
74 ## BEGIN APPLICATION SPECIFIC CONFIGURATION
77 # all_platforms is a list of all supported target platforms. Maintain
78 # alphabetically by architecture, generic-gnu last.
79 all_platforms="${all_platforms} armv5te-linux-rvct"
80 all_platforms="${all_platforms} armv5te-linux-gcc"
81 all_platforms="${all_platforms} armv5te-none-rvct"
82 all_platforms="${all_platforms} armv5te-symbian-gcc"
83 all_platforms="${all_platforms} armv6-darwin-gcc"
84 all_platforms="${all_platforms} armv6-linux-rvct"
85 all_platforms="${all_platforms} armv6-linux-gcc"
86 all_platforms="${all_platforms} armv6-none-rvct"
87 all_platforms="${all_platforms} armv6-symbian-gcc"
88 all_platforms="${all_platforms} iwmmxt-linux-rvct"
89 all_platforms="${all_platforms} iwmmxt-linux-gcc"
90 all_platforms="${all_platforms} iwmmxt2-linux-rvct"
91 all_platforms="${all_platforms} iwmmxt2-linux-gcc"
92 all_platforms="${all_platforms} armv7-darwin-gcc" #neon Cortex-A8
93 all_platforms="${all_platforms} armv7-linux-rvct" #neon Cortex-A8
94 all_platforms="${all_platforms} armv7-linux-gcc" #neon Cortex-A8
95 all_platforms="${all_platforms} armv7-none-rvct" #neon Cortex-A8
96 all_platforms="${all_platforms} mips32-linux-gcc"
97 all_platforms="${all_platforms} ppc32-darwin8-gcc"
98 all_platforms="${all_platforms} ppc32-darwin9-gcc"
99 all_platforms="${all_platforms} ppc32-linux-gcc"
100 all_platforms="${all_platforms} ppc64-darwin8-gcc"
101 all_platforms="${all_platforms} ppc64-darwin9-gcc"
102 all_platforms="${all_platforms} ppc64-linux-gcc"
103 all_platforms="${all_platforms} sparc-solaris-gcc"
104 all_platforms="${all_platforms} x86-darwin8-gcc"
105 all_platforms="${all_platforms} x86-darwin8-icc"
106 all_platforms="${all_platforms} x86-darwin9-gcc"
107 all_platforms="${all_platforms} x86-darwin9-icc"
108 all_platforms="${all_platforms} x86-linux-gcc"
109 all_platforms="${all_platforms} x86-linux-icc"
110 all_platforms="${all_platforms} x86-solaris-gcc"
111 all_platforms="${all_platforms} x86-win32-gcc"
112 all_platforms="${all_platforms} x86-win32-vs7"
113 all_platforms="${all_platforms} x86-win32-vs8"
114 all_platforms="${all_platforms} x86-win32-vs9"
115 all_platforms="${all_platforms} x86_64-darwin9-gcc"
116 all_platforms="${all_platforms} x86_64-darwin10-gcc"
117 all_platforms="${all_platforms} x86_64-linux-gcc"
118 all_platforms="${all_platforms} x86_64-linux-icc"
119 all_platforms="${all_platforms} x86_64-solaris-gcc"
120 all_platforms="${all_platforms} x86_64-win64-vs8"
121 all_platforms="${all_platforms} x86_64-win64-vs9"
122 all_platforms="${all_platforms} universal-darwin8-gcc"
123 all_platforms="${all_platforms} universal-darwin9-gcc"
124 all_platforms="${all_platforms} generic-gnu"
126 # all_targets is a list of all targets that can be configured
127 # note that these should be in dependency order for now.
128 all_targets="libs examples docs"
130 # all targets available are enabled, by default.
131 for t in ${all_targets}; do
132 [ -f ${source_path}/${t}.mk ] && enable ${t}
135 # check installed doxygen version
136 doxy_version=$(doxygen --version 2>/dev/null)
137 doxy_major=${doxy_version%%.*}
138 if [ ${doxy_major:-0} -ge 1 ]; then
139 doxy_version=${doxy_version#*.}
140 doxy_minor=${doxy_version%%.*}
141 doxy_patch=${doxy_version##*.}
143 [ $doxy_major -gt 1 ] && enable doxygen
144 [ $doxy_minor -gt 5 ] && enable doxygen
145 [ $doxy_minor -eq 5 ] && [ $doxy_patch -ge 3 ] && enable doxygen
148 # install everything except the sources, by default. sources will have
149 # to be enabled when doing dist builds, since that's no longer a common
151 enabled doxygen && php -v >/dev/null 2>&1 && enable install_docs
156 enable fast_unaligned #allow unaligned accesses, if supported by hw
158 enable spatial_resampling
162 [ -d ${source_path}/../include ] && enable alt_tree_layout
164 [ -d ${source_path}/${d} ] && disable alt_tree_layout;
167 if ! enabled alt_tree_layout; then
168 # development environment
169 [ -d ${source_path}/vp8 ] && CODECS="${CODECS} vp8_encoder vp8_decoder"
171 # customer environment
172 [ -f ${source_path}/../include/vpx/vp8cx.h ] && CODECS="${CODECS} vp8_encoder"
173 [ -f ${source_path}/../include/vpx/vp8dx.h ] && CODECS="${CODECS} vp8_decoder"
175 [ -f ${source_path}/../lib/*/*mt.lib ] && soft_enable static_msvcrt
178 CODECS="$(echo ${CODECS} | tr ' ' '\n')"
179 CODEC_FAMILIES="$(for c in ${CODECS}; do echo ${c%_*}; done | sort | uniq)"
300 --disable-codecs) for c in ${CODECS}; do disable $c; done ;;
301 *) process_common_cmdline "$opt"
307 post_process_cmdline() {
310 # If the codec family is disabled, disable all components of that family.
311 # If the codec family is enabled, enable all components of that family.
312 log_echo "Configuring selected codecs"
313 for c in ${CODECS}; do
314 disabled ${c%%_*} && disable ${c}
315 enabled ${c%%_*} && enable ${c}
318 # Enable all detected codecs, if they haven't been disabled
319 for c in ${CODECS}; do soft_enable $c; done
321 # Enable the codec family if any component of that family is enabled
322 for c in ${CODECS}; do
323 enabled $c && enable ${c%_*}
326 # Set the {en,de}coders variable if any algorithm in that class is enabled
327 for c in ${CODECS}; do
328 enabled ${c} && enable ${c##*_}s
334 enabled child || write_common_config_banner
335 enabled universal || write_common_target_config_h ${BUILD_PFX}vpx_config.h
337 # TODO: add host tools target (obj_int_extract, etc)
339 # For fat binaries, call configure recursively to configure for each
340 # binary architecture to be included.
341 if enabled universal; then
342 # Call configure (ourselves) for each subarchitecture
343 for arch in $fat_bin_archs; do
344 BUILD_PFX=${arch}/ toolchain=${arch} $self --child $cmdline_args || exit $?
348 # The write_common_config (config.mk) logic is deferred until after the
349 # recursive calls to configure complete, becuase we want our universal
350 # targets to be executed last.
351 write_common_config_targets
352 enabled universal && echo "FAT_ARCHS=${fat_bin_archs}" >> config.mk
354 # Calculate the default distribution name, based on the enabled features
357 for cf in $CODEC_FAMILIES; do
358 if enabled ${cf}_encoder && enabled ${cf}_decoder; then
359 DIST_DIR="${DIST_DIR}-${cf}"
360 elif enabled ${cf}_encoder; then
361 DIST_DIR="${DIST_DIR}-${cf}cx"
362 elif enabled ${cf}_decoder; then
363 DIST_DIR="${DIST_DIR}-${cf}dx"
366 enabled debug_libs && DIST_DIR="${DIST_DIR}-debug"
367 enabled codec_srcs && DIST_DIR="${DIST_DIR}-src"
368 ! enabled postproc && DIST_DIR="${DIST_DIR}-nopost"
369 ! enabled multithread && DIST_DIR="${DIST_DIR}-nomt"
370 ! enabled install_docs && DIST_DIR="${DIST_DIR}-nodocs"
371 DIST_DIR="${DIST_DIR}-${tgt_isa}-${tgt_os}"
373 win*) enabled static_msvcrt && DIST_DIR="${DIST_DIR}mt" || DIST_DIR="${DIST_DIR}md"
374 DIST_DIR="${DIST_DIR}-${tgt_cc}"
377 if [ -f "${source_path}/build/make/version.sh" ]; then
378 local ver=`"$source_path/build/make/version.sh" --bare $source_path`
379 DIST_DIR="${DIST_DIR}-${ver}"
380 VERSION_STRING=${ver}
382 VERSION_PATCH=${ver##*.}
384 VERSION_MINOR=${ver##*.}
386 VERSION_MAJOR=${ver%.*}
388 enabled child || cat <<EOF >> config.mk
391 ifeq (\$(MAKECMDGOALS),dist)
392 DIST_DIR?=${DIST_DIR}
394 DIST_DIR?=\$(DESTDIR)${prefix}
396 LIBSUBDIR=${libdir##${prefix}/}
398 VERSION_STRING=${VERSION_STRING}
400 VERSION_MAJOR=${VERSION_MAJOR}
401 VERSION_MINOR=${VERSION_MINOR}
402 VERSION_PATCH=${VERSION_PATCH}
404 CONFIGURE_ARGS=${CONFIGURE_ARGS}
406 enabled child || echo "CONFIGURE_ARGS?=${CONFIGURE_ARGS}" >> config.mk
409 # Write makefiles for all enabled targets
411 for tgt in libs examples docs solution; do
412 local tgt_fn="$tgt-$toolchain.mk"
414 if enabled $tgt; then
415 echo "Creating makefiles for ${toolchain} ${tgt}"
416 write_common_target_config_mk $tgt_fn ${BUILD_PFX}vpx_config.h
424 if enabled shared; then
425 # Can only build shared libs on a subset of platforms. Doing this check
426 # here rather than at option parse time because the target auto-detect
427 # magic happens after the command line has been parsed.
428 enabled linux || die "--enable-shared only supported on ELF for now"
430 if [ -z "$CC" ]; then
431 echo "Bypassing toolchain for environment detection."
432 enable external_build
434 log fake_check_header "$@"
437 var=`echo $header | sed 's/[^A-Za-z0-9_]/_/g'`
446 [ -f "${d##-I}/$header" ] && result=true && break
455 check_header stdio.h || die "Unable to invoke compiler: ${CC} ${CFLAGS}"
456 check_ld <<EOF || die "Toolchain is unable to link executables"
457 int main(void) {return 0;}
459 # check system headers
460 check_header stdint.h
461 check_header pthread.h
462 check_header sys/mman.h
464 check_header vpx/vpx_integer.h -I${source_path} && enable vpx_ports
467 process_toolchain() {
468 process_common_toolchain
470 # Handle universal binaries for this architecture
473 local darwin_ver=${tgt_os##darwin}
474 fat_bin_archs="$fat_bin_archs ppc32-${tgt_os}-gcc"
477 fat_bin_archs="$fat_bin_archs x86-${tgt_os}-${tgt_cc}"
478 if [ $darwin_ver -gt 8 ]; then
479 fat_bin_archs="$fat_bin_archs x86_64-${tgt_os}-${tgt_cc}"
485 # Enable some useful compiler flags
487 enabled werror && check_add_cflags -Werror
488 check_add_cflags -Wall
489 check_add_cflags -Wdeclaration-after-statement
490 check_add_cflags -Wdisabled-optimization
491 check_add_cflags -Wpointer-arith
492 check_add_cflags -Wtype-limits
493 check_add_cflags -Wcast-qual
494 enabled extra_warnings || check_add_cflags -Wno-unused-function
498 enabled werror && check_add_cflags -Werror
499 check_add_cflags -Wall
500 check_add_cflags -Wpointer-arith
502 # ICC has a number of floating point optimizations that we disable
503 # in favor of deterministic output WRT to other compilers
504 add_cflags -fp-model precise
507 # Enable extra, harmless warnings. These might provide additional insight
508 # to what the compiler is doing and why, but in general, but they shouldn't
509 # be treated as fatal, even if we're treating warnings as errors.
511 -Wdisabled-optimization
514 enabled gcc && EXTRA_WARNINGS="${GCC_EXTRA_WARNINGS}"
515 RVCT_EXTRA_WARNINGS="
518 enabled rvct && EXTRA_WARNINGS="${RVCT_EXTRA_WARNINGS}"
519 if enabled extra_warnings; then
520 for w in ${EXTRA_WARNINGS}; do
521 check_add_cflags ${w}
522 enabled gcc && enabled werror && check_add_cflags -Wno-error=${w}
526 # ccache only really works on gcc toolchains
527 enabled gcc || soft_disable ccache
528 if enabled mips; then
529 enable dequant_tokens
533 # Enable the postbuild target if building for visual studio.
537 vs_version=${tgt_cc##vs}
538 all_targets="${all_targets} solution"
542 # Other toolchain specific defaults
543 case $toolchain in x86*|ppc*|universal*) soft_enable postproc;; esac
545 if enabled postproc_visualizer; then
546 enabled postproc || die "postproc_visualizer requires postproc to be enabled"
552 ## END APPLICATION SPECIFIC CONFIGURATION
556 cat <<EOF > ${BUILD_PFX}vpx_config.c
557 static const char* const cfg = "$CONFIGURE_ARGS";
558 const char *vpx_codec_build_config(void) {return cfg;}